package info.textgrid.middleware;

import info.textgrid.middleware.oaipmh.OAIPMHType;

import java.text.ParseException;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import javax.xml.bind.JAXBElement;

import org.apache.cxf.jaxrs.client.JAXRSClientFactory;

/**
 *
 */
public class OaiPmhClient {

	private String				identifier;
	private String				metadataPrefix;
	private String				set;
	private String				from;
	private String				until;
	private String				resumptionToken;
	private OAIPMHProducer		producer;

	/**
	 * @param endpoint
	 */
	public OaiPmhClient(String endpoint) {
		this.producer = JAXRSClientFactory.create(endpoint + "/oai",OAIPMHProducer.class);
	}

	/**
	 * @param verb
	 * @return
	 * @throws ParseException
	 */
	public JAXBElement<OAIPMHType> request(String verb) throws ParseException {		
		return producer.getRequest(verb, identifier, metadataPrefix, set, from,
				until, resumptionToken);

	}

	/**
	 * @return
	 */
	@GET
	@Path("/version")
	@Produces(MediaType.TEXT_PLAIN)
	public String getVersion() {
		return OaipmhServiceVersion.BUILDNAME + "-"
				+ OaipmhServiceVersion.VERSION + "."
				+ OaipmhServiceVersion.BUILDDATE;
	}

}
